<?php
/*
 * A plugin that allows you to add rel="nofollow" on all external link
 * Plugin for Joomla 2.5 Version 1.3
 * License: http://www.gnu.org/copyleft/gpl.html
 * Authors: marco maria leoni
 * Copyright (c) 2010 - 2013 marco maria leoni web consulting - http: www.mmleoni.net
 * Project page at http://www.mmleoni.net/marco-rel-nofollow
 * *** Last update: Dec 23rd, 2013 ***
*/


// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgContentMarcobuymeabeer extends JPlugin{
	protected static $itemCount = 0;

	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	public function onContentPrepare($context, &$row, &$params, $page = 0){
		if (is_object($row)){
			return $this->renderPayPal($row->text, $params);
		}
		return $this->renderPayPal($row, $params);
	}

	protected function renderPayPal(&$text, &$params){
		/*
		 * Check for presence of {marcobuymeabeer ... } 
		 */
		
		if (JString::strpos($text, '{marcobuymeabeer') === false) {
			return true;
		}

		$obj = new stdClass();

		$obj->count = 0;
		// short locale
		$obj->locale = strtoupper(substr(JFactory::getLanguage()->getTag(), 0, 2));
		// full locale code
		$obj->localeFull = str_replace('-', '_', JFactory::getLanguage()->getTag());
		
		// Load plugin default params info

		// target of form
		$obj->target = $this->params->get('target', '_top');
		// email of account
		$obj->business = $this->params->get('business');
		// name of organization, reason
		$obj->item_name = $this->params->get('item_name');
		// currency for the donation
		$obj->currency_code = $this->params->get('currency_code');
		//beer image
		$obj->image = 'plugins/content/marcobuymeabeer/assets/' . $this->params->get('image');
		// donation text
		$obj->text = JText::_($this->params->get('text'));
		$obj->legend = JText::_($this->params->get('legend', ''));
		$obj->amountText = JText::_($this->params->get('amountText', ''));
		//list of options
		$obj->amountList = $this->amountListToTag($this->params->get('amountList'), $obj->currency_code);
		// 'CC' if button includes credit card image
		$obj->creditCard = $this->params->get('creditCard');
		
		$obj->formOrientation = $this->params->get('useCss');
		if ($this->params->get('useCss')!='n'){
			JFactory::getDocument()->addStyleSheet('plugins/content/marcobuymeabeer/assets/buy-me-a-beer.css');
		}
	
		$placeholders = array();
		preg_match_all( '/{marcobuymeabeer\s*([^}]*)}/i', $text, $placeholders, PREG_SET_ORDER );

		foreach ($placeholders as $placeholder){
		//die('found');
			$mbb = clone $obj;
			$mbb->count = ++self::$itemCount;
			$pattern = "/(\w+)(\s*=\s*(?:\".*?\"|'.*?'|[^'\">\s]+))?/i"; // get attributes
			$attribs = array();
			preg_match_all ( $pattern, $placeholder[1], $attribs, PREG_SET_ORDER );
			
			$atlist = array();
			foreach ($attribs as $attrib){
				//relaxed
				//$atlist[strtolower($attrib[1])] = preg_replace("/=\s*[\"']?([^'\"]*)[\"']?/", "$1", $attrib[2]);
				//strict
				$atlist[strtolower($attrib[1])] = preg_replace("/=\s*(?:\"([^\"]*)\")|(?:'([^']*)')/", "$1", $attrib[2]);
			}
			
			// parameters override
			if(isset($atlist['business'])){
				$mbb->business= $atlist['business'];
			}
			
			if(isset($atlist['item_name'])){
				$mbb->item_name = $atlist['item_name'];
			}

			if(isset($atlist['text'])){
				$mbb->text = JText::_($atlist['text']);
			}

			if(isset($atlist['legend'])){
				$mbb->legend = JText::_($atlist['legend']);
			}

			if(isset($atlist['amount_text'])){
				$mbb->amountText = JText::_($atlist['amount_text']);
			}
			
			if(isset($atlist['form_orientation'])){
				$mbb->formOrientation = $atlist['form_orientation'];
			}
			
			if(isset($atlist['image'])){
				$mbb->image= $atlist['image'];
			}
			
			if(isset($atlist['currency_code'])){
				$mbb->currency_code= $atlist['currency_code'];
			}

			if(isset($atlist['amount_list'])){
				$mbb->amountList= $this->amountListToTag($atlist['amount_list'], $mbb->currency_code);
			}
			
			$jv = new JVersion();
			if($jv->RELEASE=='2.5'){
				$path = 'plugins/content/marcobuymeabeer/tmpl/default.php';
			}else{
				// Get the path for the layout file
				$path = JPluginHelper::getLayoutPath('content', 'marcobuymeabeer');
			}
			// Render the marcobuymeabeer
			ob_start();
			include $path;
			$tmpl = ob_get_clean(); 
			
			//$text = str_replace($placeholder[0], $tmpl, $text);
			// replace ONLY the first occurrence
			$pos = strpos($text,$placeholder[0]);
			if ($pos !== false) {
				$text = substr_replace($text,$tmpl,$pos,strlen($placeholder[0]));
			}
			
		}
		return true;
	}
	
	protected function amountListToTag($amountList, $currency_code){
		if(!$amountList) return '';
		
		$list = explode(',', preg_replace('/\s*/', '', $amountList));
		if(count($list)==1){
			$html = sprintf('<input name="amount" value="%01.2f" type="hidden" />', (float)$list[0]);;
		}else{
			$html = '<select name="amount">';
			foreach($list as $item){
				$html .= sprintf('<option value="%01.2f">%s %s</option>', (float)$item, $item, $currency_code);
			}
			$html .= '</select>';
		}
		return $html;
	}
	
}	
?>